#include "lpc2103.h" // gechecked, laut Datenblatt okay!
#include "main.h"
#include <math.h>
#include "/usr/local/arm/arm-elf/include/sys/string.h"
#include "/usr/local/arm/arm-elf/include/sys/types.h"

# compiled with arm-elf-gcc (GCC) 4.1.0

int main(void)
{
	unsigned int i;	

	sysinit();
	
	// set-up interrupts
	MEMMAP = (1 << 0);							// map interrupt vectors space into FLASH
	VICIntEnClr = 0xFFFFFFFF;					// clear all interrupts
	VICIntSelect = 0x00000000;					// clear all FIQ selections == alles ist trad. IRQ
	VICDefVectAddr = (unsigned long) reset;		// point unvectored IRQs to reset() (aus startup)

	// Timer 2, siehe: http://www.keil.com/forum/docs/thread10347.asp
	T2PR = 0x00000005; //Load prescaler
	T2TCR = 0x00000002; //Reset counter and prescaler
	T2MCR = 0x00000003; //match reset the counter and generate an interrupt
	T2MR0 = 0x00000010; //cycle time
	T2TCR = 0x00000001; //enable timer
	VICVectAddr4 = (unsigned long)ISR; //Set the timer ISR vector address
	VICVectCntl4 = 0x0000003A; //Set channel control
	VICIntEnable |= 0x04000000; //Enable the TIMER2 interrupt

	// FIO
	FIODIR |= 1 << 4; // P0.26 is an output
	while( 1 )
	{
		i++;
	}
}

void __attribute__ ((interrupt("IRQ"))) ISR(void)
{
	FIOCLR = 1 << 4;
	T2IR = 0x00000001; 			//Clear match 0 interrupt
	VICVectAddr = 0x00000000; 	//Dummy write to signal end of interrupt
	FIOSET = 1 << 4;
}

void sysinit(void)
{
	// PLL Setup
	PLLCFG |=  (1 << 0) | (1 << 5); 	  // M=1 und P = 1, schon dekrementiert
	// das sollten 40 MHz Bustakt ergeben
	
	// PLL starten
	PLLCON |= (1 << 0);
	PLLFEED = 0xAA;                       // Make it happen.  These two updates
	PLLFEED = 0x55;                       // MUST occur in sequence.
	
	// wait for settling PLL
	while (!(PLLSTAT &  (1 << 10)))
	continue;

	// PLL starten und connectieren
	PLLCON = (1 << 1) | (1 << 0);
	PLLFEED = 0xAA;                       // Make it happen.  These two updates
	PLLFEED = 0x55;                       // MUST occur in sequence.

	// Memory Acceleration
	MAMTIM = 3;	// 3 cycles
	MAMCR = 2; // full acceleration

	// peripheral clock
	APBDIV = 1; // periph clock = processor clock

	// fast GPIO
	SCS = (1 << 0); //enable fast GPIO in System Control Setup

}


